//
// Form validation
//

// Validation de TOUS les champs
private function validateFields() : Boolean
{
	if (currentState == "Login")
		return validateLoginFields();
	else
	{
		var login:Boolean = validateLoginFields();
		var register:Boolean = validateRegisterFields();
		return login && register;
	}
}

// Validation des champs de l'état LOGIN
private function validateLoginFields():Boolean
{
	var username : Boolean = usernameIsValid();
	var password : Boolean = passwordIsValid();
	
	return username && 
		password;
}

// Validation des champs de l'état REGISTER
private function validateRegisterFields():Boolean
{
	var confirm : Boolean = confirmIsValid();
	var firstname : Boolean = firstnameIsValid();
	var lastname : Boolean = lastnameIsValid();
	var birthdate : Boolean = birthdateIsValid();
	var email : Boolean = emailIsValid();
	
	return confirm &&
		firstname &&
		lastname &&
		birthdate &&
		email;
}

// Validation du champ USERNAME
private function usernameIsValid():Boolean
{
	stringValidator.listener = txtUsername;
	stringValidator.minLength = 3;
	stringValidator.maxLength = 50;
	var vResult:ValidationResultEvent = stringValidator.validate(txtUsername.text);
	return vResult.type == ValidationResultEvent.VALID;
}

// Validation du champ PASSWORD
private function passwordIsValid():Boolean
{
	stringValidator.listener = txtPassword;
	stringValidator.minLength = 4;
	stringValidator.maxLength = 50;
	var vResult:ValidationResultEvent = stringValidator.validate(txtPassword.text);
	return vResult.type == ValidationResultEvent.VALID;
}

// Validation du champ CONFIRM
private function confirmIsValid():Boolean
{
	pwdConfirmationValidator.listener = txtConfim;
	var vResult:ValidationResultEvent = pwdConfirmationValidator.validate(txtPassword);
	return vResult.type == ValidationResultEvent.VALID;
}

// Validation du champ FIRSTNAME
private function firstnameIsValid():Boolean
{
	stringValidator.listener = txtFirstname;
	stringValidator.minLength = 3;
	stringValidator.maxLength = 50;
	var vResult:ValidationResultEvent = stringValidator.validate(txtFirstname.text);
	return vResult.type == ValidationResultEvent.VALID;
}

// Validation du champ LASTNAME
private function lastnameIsValid():Boolean
{
	stringValidator.listener = txtLastname;
	stringValidator.minLength = 3;
	stringValidator.maxLength = 50;
	var vResult:ValidationResultEvent = stringValidator.validate(txtLastname.text);
	return vResult.type == ValidationResultEvent.VALID;
}

// Validation du champ BIRTHDATE
private function birthdateIsValid():Boolean
{
	dateValidator.listener = txtBirthDate;
	var vResult:ValidationResultEvent = dateValidator.validate(txtBirthDate.text);
	return vResult.type == ValidationResultEvent.VALID;
}

// Validation du champ EMAIL
private function emailIsValid():Boolean
{
	emailValidator.listener = txtEmail;
	var vResult:ValidationResultEvent = emailValidator.validate(txtEmail.text);
	return vResult.type == ValidationResultEvent.VALID;
}